// HelloDX11.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "HelloDX11.h"
#include <D3D11.h>

#define MAX_LOADSTRING 100

#pragma comment( lib, "d3d11.lib" )

// O[oϐ:
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX
HWND	g_hWindow;

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);


int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ɃR[h}ĂB
	MSG msg;
	HACCEL hAccelTable;

	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_HELLODX11, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// AvP[V̏s܂:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_HELLODX11));

	// DirectX
	// Xbv`FC̐ݒ
	DXGI_SWAP_CHAIN_DESC sd;
	ZeroMemory( &sd, sizeof(sd) );
	sd.BufferCount = 1;
	sd.BufferDesc.Width = 640;
	sd.BufferDesc.Height = 480;
	sd.BufferDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
	sd.BufferDesc.RefreshRate.Numerator = 60;
	sd.BufferDesc.RefreshRate.Denominator = 1;
	sd.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
	sd.OutputWindow = g_hWindow;
	sd.SampleDesc.Count = 1;
	sd.SampleDesc.Quality = 0;
	sd.Windowed = TRUE;
	sd.Flags = DXGI_SWAP_CHAIN_FLAG_ALLOW_MODE_SWITCH;

	// @\x̐ݒ
	//  v鏇Ԃɕׂ.
	D3D_FEATURE_LEVEL featureLevels[] = {
		D3D_FEATURE_LEVEL_11_0, D3D_FEATURE_LEVEL_10_0, D3D_FEATURE_LEVEL_9_3,
	};
	UINT nLevelCount = sizeof( featureLevels ) / sizeof( featureLevels[0] );


	D3D_FEATURE_LEVEL supportLevel; // foCXɑIꂽ@\x.
	ID3D11Device*	  pd3dDevice = 0;   
	IDXGISwapChain*   pSwapChain = 0;
	ID3D11DeviceContext*	pImmediateContext = 0;

	// foCX̍쐬.
	HRESULT hr = D3D11CreateDeviceAndSwapChain( 
				NULL, 
				D3D_DRIVER_TYPE_HARDWARE, 
				NULL, 
				0, 
				featureLevels, 
				nLevelCount, 
				D3D11_SDK_VERSION, 
				&sd, 
				&pSwapChain, 
				&pd3dDevice, 
				&supportLevel,
				&pImmediateContext );
	if( FAILED(hr) )
	{
		OutputDebugStringA( "D3D11CreateDeviceAndSwapChain failed.\n" );
	}

	// obNobt@̏
	ID3D11Texture2D*	pBackBuffer = 0;
	ID3D11RenderTargetView*	pRenderTargetView = 0;
	hr = pSwapChain->GetBuffer( 0, __uuidof(ID3D11Texture2D), (void**)&pBackBuffer );
	if( FAILED(hr) )
	{
		OutputDebugStringA( "GetBufferŎs.\n" );
	}
	hr = pd3dDevice->CreateRenderTargetView( pBackBuffer, NULL, &pRenderTargetView );
	if( FAILED(hr) )
	{
		OutputDebugStringA( "CreateRenderTargetView [Backbuffer] failed.\n" );
	}
	if( pBackBuffer )
	{	// obNobt@͂gȂ̂ŉ.
		pBackBuffer->Release();
		pBackBuffer = 0;
	}
	// obNobt@pɃfvXEXeV̏
	D3D11_TEXTURE2D_DESC descDepth;
	ZeroMemory( &descDepth, sizeof(descDepth) );
	descDepth.Width = 640; descDepth.Height = 480;
	descDepth.MipLevels = 1;
	descDepth.ArraySize = 1;
	descDepth.Format = DXGI_FORMAT_D24_UNORM_S8_UINT;
	descDepth.SampleDesc.Count = 1; descDepth.SampleDesc.Quality = 0;
	descDepth.Usage = D3D11_USAGE_DEFAULT;
	descDepth.BindFlags = D3D11_BIND_DEPTH_STENCIL;

	ID3D11Texture2D* pDepthStencil = 0;
	hr = pd3dDevice->CreateTexture2D( &descDepth, NULL, &pDepthStencil );

	D3D11_DEPTH_STENCIL_VIEW_DESC descDepthStencilView;
	ZeroMemory( &descDepthStencilView, sizeof(descDepthStencilView) );
	descDepthStencilView.Format = descDepth.Format;
	descDepthStencilView.ViewDimension =  D3D11_DSV_DIMENSION_TEXTURE2D;
	descDepthStencilView.Texture2D.MipSlice = 0;

	ID3D11DepthStencilView* pDepthStencilView = 0;
	hr = pd3dDevice->CreateDepthStencilView( pDepthStencil, &descDepthStencilView, &pDepthStencilView );

	if( pDepthStencil )
	{
		pDepthStencil->Release();
		pDepthStencil = 0;
	}

	// 쐬er[`^[Qbgɐݒ.
	pImmediateContext->OMSetRenderTargets( 1, &pRenderTargetView, pDepthStencilView );

	// r[|[gݒ
	D3D11_VIEWPORT vp;
	vp.TopLeftX = 0;
	vp.TopLeftY = 0;
	vp.Width = 640;
	vp.Height = 480;
	vp.MinDepth = 0.0f;
	vp.MaxDepth = 1.0f;
	pImmediateContext->RSSetViewports( 1, &vp );

	// C bZ[W [v:
	do {
		if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
		{
			if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		} else {
			// ʂ̃NA
			float  clearColor[4] = { 0.0f, 0.0f, 0.25f, 0.0f };
			pImmediateContext->ClearRenderTargetView( pRenderTargetView, clearColor );
			pImmediateContext->ClearDepthStencilView( pDepthStencilView, D3D11_CLEAR_DEPTH | D3D11_CLEAR_STENCIL, 1.0f, 0 );
			pSwapChain->Present( 0, 0 );
		}
	} while( msg.message != WM_QUIT );

	if( pImmediateContext )
	{	// foCX̃Xe[gԂɖ߂B
		pImmediateContext->ClearState();
	}

	if( pRenderTargetView ) { pRenderTargetView->Release(); pRenderTargetView = 0; }
	if( pDepthStencilView ) { pDepthStencilView->Release(); pDepthStencilView = 0; }
	if( pImmediateContext ) { pImmediateContext->Release(); pImmediateContext = 0; }
	if( pd3dDevice ) { pd3dDevice->Release(); pd3dDevice = 0; }
	if( pSwapChain ) { pSwapChain->Release(); pSwapChain = 0; }


	return (int) msg.wParam;
}



//
//  ֐: MyRegisterClass()
//
//  ړI: EBhE NXo^܂B
//
//  Rg:
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//    Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_HELLODX11));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_HELLODX11);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI: CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // O[oϐɃCX^Xi[܂B

   RECT rc = { 0, 0, 640, 480 };
   AdjustWindowRect( &rc, WS_OVERLAPPEDWINDOW, TRUE );
   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
	   CW_USEDEFAULT, 0, rc.right - rc.left, rc.bottom - rc.top, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   g_hWindow = hWnd;
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI:  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Iꂽj[̉:
		switch (wmId)
		{
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: `R[hɒǉĂ...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}
